define([
    "dojo/_base/declare",
    // Resources
    "epi/i18n!epi/nls/episerver.cms.contentediting.toolbar.buttons.cancelandedit",
    // Parent class
    "epi-cms/project/command/_ProjectCommand"
], function(
    declare,
    // Resources
    localizations,
    // Parent class
    _ProjectCommand
) {

    return declare([_ProjectCommand], {
        // tags:
        //      internal

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "publishmenu",

        // iconClass: [public] String
        //      The icon class of the command to be used in visual elements.
        iconClass: "epi-iconPen",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: localizations.label,

        _execute: function () {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected
            var model = this.model;

            return model.reactivateProject(model.selectedProject.id);
        },

        _setCanExecute: function () {
            var selectedProject = this.model.selectedProject,
                isScheduled = !!selectedProject && selectedProject.status === "delayedpublished";

            this.set("canExecute", isScheduled);
            this.set("isAvailable", isScheduled);
        }
    });
});
